After applying this patch and running configure, you MUST run this
command before "make":

    make proto


--- io.c	8 May 2004 18:03:43 -0000	1.120
+++ io.c	13 May 2004 18:57:54 -0000
@@ -222,6 +222,14 @@ static void read_msg_fd(void)
 		read_loop(fd, buf, 4);
 		redo_list_add(IVAL(buf,0));
 		break;
+	case MSG_SUCCESS:
+		if (len != 4) {
+			rprintf(FERROR, "invalid message %d:%d\n", tag, len);
+			exit_cleanup(RERR_STREAMIO);
+		}
+		read_loop(fd, buf, len);
+		io_multiplex_write(MSG_SUCCESS, buf, len);
+		break;
 	case MSG_INFO:
 	case MSG_ERROR:
 	case MSG_LOG:
@@ -637,6 +645,16 @@ static int read_unbuffered(int fd, char 
 			}
 			read_loop(fd, buffer, remaining);
 			bufferIdx = 0;
+			break;
+		case MSG_SUCCESS:
+			if (remaining != 4) {
+				rprintf(FERROR, "invalid multi-message %d:%ld\n",
+					tag, (long)remaining);
+				exit_cleanup(RERR_STREAMIO);
+			}
+			read_loop(fd, line, remaining);
+			successful_send(IVAL(line, 0));
+			remaining = 0;
 			break;
 		case MSG_INFO:
 		case MSG_ERROR:
--- main.c	10 Feb 2004 03:54:47 -0000	1.192
+++ main.c	13 May 2004 18:57:54 -0000
@@ -42,6 +42,7 @@ extern int list_only;
 extern int local_server;
 extern int log_got_error;
 extern int module_id;
+extern int need_messages_from_generator;
 extern int orig_umask;
 extern int preserve_hard_links;
 extern int protocol_version;
@@ -567,6 +568,8 @@ void start_server(int f_in, int f_out, i
 		io_start_multiplex_out(f_out);
 
 	if (am_sender) {
+		if (need_messages_from_generator)
+			io_start_multiplex_in(f_in);
 		if (!read_batch) {
 			recv_exclude_list(f_in);
 			if (cvs_exclude)
@@ -632,6 +635,9 @@ int client_run(int f_in, int f_out, pid_
 		io_flush(FULL_FLUSH);
 		exit_cleanup(status);
 	}
+
+	if (need_messages_from_generator)
+		io_start_multiplex_out(f_out);
 
 	if (argc == 0) {
 		list_only = 1;
--- options.c	6 May 2004 21:08:01 -0000	1.148
+++ options.c	13 May 2004 18:57:55 -0000
@@ -84,6 +84,7 @@ int copy_unsafe_links = 0;
 int size_only = 0;
 int bwlimit = 0;
 int delete_after = 0;
+int delete_sent_files = 0;
 int only_existing = 0;
 int opt_ignore_existing = 0;
 int max_delete = 0;
@@ -91,6 +92,7 @@ int ignore_errors = 0;
 int modify_window = 0;
 int blocking_io = -1;
 int checksum_seed = 0;
+int need_messages_from_generator = 0;
 unsigned int block_size = 0;
 
 
@@ -254,6 +256,7 @@ void usage(enum logcode F)
   rprintf(F,"     --delete                delete files that don't exist on the sending side\n");
   rprintf(F,"     --delete-excluded       also delete excluded files on the receiving side\n");
   rprintf(F,"     --delete-after          receiver deletes after transferring, not before\n");
+  rprintf(F,"     --delete-sent-files     updated/sent files are removed from sending side\n");
   rprintf(F,"     --ignore-errors         delete even if there are I/O errors\n");
   rprintf(F,"     --max-delete=NUM        don't delete more than NUM files\n");
   rprintf(F,"     --partial               keep partially transferred files\n");
@@ -303,8 +306,8 @@ void usage(enum logcode F)
 }
 
 enum {OPT_VERSION = 1000, OPT_SENDER, OPT_EXCLUDE, OPT_EXCLUDE_FROM,
-      OPT_DELETE_AFTER, OPT_DELETE_EXCLUDED, OPT_LINK_DEST,
-      OPT_INCLUDE, OPT_INCLUDE_FROM, OPT_MODIFY_WINDOW,
+      OPT_DELETE_AFTER, OPT_DELETE_EXCLUDED, OPT_DELETE_SENT_FILES,
+      OPT_INCLUDE, OPT_INCLUDE_FROM, OPT_LINK_DEST, OPT_MODIFY_WINDOW,
       OPT_READ_BATCH, OPT_WRITE_BATCH,
       OPT_REFUSED_BASE = 9000};
 
@@ -323,6 +326,7 @@ static struct poptOption long_options[] 
   {"ignore-existing",  0,  POPT_ARG_NONE,   &opt_ignore_existing, 0, 0, 0 },
   {"delete-after",     0,  POPT_ARG_NONE,   0,              OPT_DELETE_AFTER, 0, 0 },
   {"delete-excluded",  0,  POPT_ARG_NONE,   0,              OPT_DELETE_EXCLUDED, 0, 0 },
+  {"delete-sent-files",0,  POPT_ARG_NONE,   0,              OPT_DELETE_SENT_FILES, 0, 0 },
   {"force",            0,  POPT_ARG_NONE,   &force_delete, 0, 0, 0 },
   {"numeric-ids",      0,  POPT_ARG_NONE,   &numeric_ids, 0, 0, 0 },
   {"exclude",          0,  POPT_ARG_STRING, 0,              OPT_EXCLUDE, 0, 0 },
@@ -509,6 +513,11 @@ int parse_arguments(int *argc, const cha
 			delete_mode = 1;
 			break;
 
+		case OPT_DELETE_SENT_FILES:
+			delete_sent_files = 1;
+			need_messages_from_generator = 1;
+			break;
+
 		case OPT_EXCLUDE:
 			add_exclude(&exclude_list, poptGetOptArg(pc), 0);
 			break;
@@ -964,6 +973,9 @@ void server_options(char **args,int *arg
 			args[ac++] = "--from0";
 		}
 	}
+
+	if (delete_sent_files)
+		args[ac++] = "--delete-sent-files";
 
 	*argc = ac;
 	return;
--- receiver.c	13 May 2004 07:08:22 -0000	1.77
+++ receiver.c	13 May 2004 18:57:55 -0000
@@ -46,6 +46,7 @@ extern int module_id;
 extern int ignore_errors;
 extern int orig_umask;
 extern int keep_partial;
+extern int delete_sent_files;
 
 static void delete_one(char *fn, int is_dir)
 {
@@ -293,7 +294,7 @@ int recv_files(int f_in,struct file_list
 	char *fname, fbuf[MAXPATHLEN];
 	char template[MAXPATHLEN];
 	char fnametmp[MAXPATHLEN];
-	char *fnamecmp;
+	char *fnamecmp, numbuf[4];
 	char fnamecmpbuf[MAXPATHLEN];
 	struct map_struct *mapbuf;
 	int i;
@@ -475,16 +476,20 @@ int recv_files(int f_in,struct file_list
 
 		cleanup_disable();
 
-		if (!recv_ok) {
+		if (recv_ok) {
+			if (delete_sent_files) {
+				SIVAL(numbuf, 0, i);
+				send_msg(MSG_SUCCESS, numbuf, 4);
+			}
+		} else {
 			if (csum_length == SUM_LENGTH) {
 				rprintf(FERROR,"ERROR: file corruption in %s. File changed during transfer?\n",
 					full_fname(fname));
 			} else {
-				char buf[4];
 				if (verbose > 1)
 					rprintf(FINFO,"redoing %s(%d)\n",fname,i);
-				SIVAL(buf, 0, i);
-				send_msg(MSG_REDO, buf, 4);
+				SIVAL(numbuf, 0, i);
+				send_msg(MSG_REDO, numbuf, 4);
 			}
 		}
 	}
--- rsync.h	13 May 2004 18:51:22 -0000	1.203
+++ rsync.h	13 May 2004 18:57:55 -0000
@@ -60,6 +60,7 @@
 #define FLAG_TOP_DIR (1<<0)
 #define FLAG_HLINK_EOL (1<<1)	/* generator only */
 #define FLAG_MOUNT_POINT (1<<2)	/* sender only */
+#define FLAG_SENT (1<<7)	/* sender only */
 
 /* update this if you make incompatible changes */
 #define PROTOCOL_VERSION 28
@@ -123,6 +124,7 @@ enum logcode { FERROR=1, FINFO=2, FLOG=3
 /* Messages types that are sent over the message channel.  The logcode
  * values must all be present here with identical numbers. */
 enum msgcode {
+	MSG_SUCCESS=6,	/* successfully updated indicated flist index */
 	MSG_DONE=5,	/* current phase is done */
 	MSG_REDO=4,	/* reprocess indicated flist index */
 	MSG_ERROR=FERROR, MSG_INFO=FINFO, MSG_LOG=FLOG, /* remote logging */
--- rsync.yo	7 May 2004 00:18:37 -0000	1.169
+++ rsync.yo	13 May 2004 18:57:56 -0000
@@ -312,6 +312,7 @@ verb(
      --delete                delete files that don't exist on sender
      --delete-excluded       also delete excluded files on receiver
      --delete-after          receiver deletes after transfer, not before
+     --delete-sent-files     updated/sent files are removed from sender
      --ignore-errors         delete even if there are I/O errors
      --max-delete=NUM        don't delete more than NUM files
      --partial               keep partially transferred files
@@ -596,6 +597,11 @@ dit(bf(--delete-after)) By default rsync
 receiving side before transferring files to try to ensure that there is
 sufficient space on the receiving filesystem. If you want to delete
 after transferring, use the --delete-after switch. Implies --delete.
+
+dit(bf(--delete-sent-files)) This tells rsync to remove the source files
+on the sending side that are successfully transferred to the receiving
+side.  Directories are not removed, nor are files that are identical on
+both systems.
 
 dit(bf(--ignore-errors)) Tells --delete to go ahead and delete files
 even when there are I/O errors.
--- sender.c	11 May 2004 19:53:16 -0000	1.39
+++ sender.c	13 May 2004 18:57:56 -0000
@@ -27,6 +27,7 @@ extern int dry_run;
 extern int am_server;
 extern int am_daemon;
 extern int protocol_version;
+extern int delete_sent_files;
 
 
 /**
@@ -104,7 +105,29 @@ static struct sum_struct *receive_sums(i
 	return s;
 }
 
+static struct file_list *the_flist;
 
+void successful_send(int i)
+{
+	char fname[MAXPATHLEN];
+	struct file_struct *file;
+	unsigned int offset;
+
+	if (!the_flist)
+		return;
+
+	file = the_flist->files[i];
+	if (!(file->flags & FLAG_SENT))
+		return; /* We didn't send it -- impossible! */
+	if (file->basedir) {
+		offset = stringjoin(fname, sizeof fname,
+				    file->basedir, "/", NULL);
+	} else
+		offset = 0;
+	f_name_to(file, fname + offset);
+	if (delete_sent_files && do_unlink(fname) == 0 && verbose > 0)
+		rprintf(FINFO, "sender removed %s\n", fname + offset);
+}
 
 void send_files(struct file_list *flist, int f_out, int f_in)
 {
@@ -129,6 +152,8 @@ void send_files(struct file_list *flist,
 	if (verbose > 2)
 		rprintf(FINFO, "send_files starting\n");
 
+	the_flist = flist;
+
 	while (1) {
 		unsigned int offset;
 
@@ -299,6 +324,9 @@ void send_files(struct file_list *flist,
 
 		if (verbose > 2)
 			rprintf(FINFO, "sender finished %s\n", fname);
+
+		/* Flag that we actually sent this entry. */
+		file->flags |= FLAG_SENT;
 	}
 
 	if (verbose > 2)
